// used to compile            
//      g++ -o robotank robotank.cpp `mysql_config --cflags --libs` -lwiringPi -lpthread -lquickmail -lcurl
//      g++ -o robotank robotank.cpp `mysql_config --cflags --libs` -lwiringPi -lpthread -lquickmail -lcurl -ljsoncpp

// used to test memory
//      valgrind --track-origins=yes ./main

unsigned long long currentMillisOffset = 0;
unsigned long long currentMillisTime = 0;
unsigned long long currentMillis2 = 0;
unsigned long long currentMillisTracker = 0;
int timeFormat = 0;
int health = 0;
unsigned long long prevHealthMillis = 0;
int healthCount = 0;
unsigned long long prevMillisBlink = 0;
unsigned long long prevUpdateMillis = 0;
bool startupComplete = 0;
unsigned long long midnightMillis = 0;
unsigned long long nextMidnightMillis = 0;
float sleepTimeMainLoop = 1;
unsigned long long programStartMillis = 0;

unsigned long long supportID = 0;

auto startTimer = 0;
auto TotalTimer = 0;


#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <signal.h>

#include <cctype>
#include <random>
// c++ libraries
#include <stdio.h>      /* printf */
#include <math.h>       /* floor */
#include <stdlib.h>
#include <iomanip>      // std::setw
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <cstring>
#include <string.h>
#include <sstream>
#include <ctime>
#include <time.h>
#include <chrono>
#include <iostream>
#include <fstream>
#include "jsoncpp/json/json.h"
#include <wiringPi.h>
#include <sys/ioctl.h> // required for I2C device usage
#include <linux/i2c-dev.h> // required for constant definitions
#include <cstdlib>
#include <pthread.h>  // multithreading
#include <curl/curl.h>
#include <quickmail.h>		// quickmail email library
#include <vector>  // for decoding
#include </usr/include/mariadb/mysql.h>
// #include </usr/include/mysql/mysql.h>
// #include </usr/include/PiPCA9685/PCA9685.h>
// #include </var/www/html/libraries/Adafruit_PWM_Library/Adafruit_PWMServoDriver.cpp>
// program files
size_t len = 0;
std::string outgoingDataString = "";
#include </var/www/html/cpp/mysql.cpp>
#include </var/www/html/cpp/update.h>
#include </var/www/html/cpp/email.h>
#include </var/www/html/cpp/pca9685.h>
#include </var/www/html/cpp/i2c.h>
#include </var/www/html/cpp/system.h>
#include </var/www/html/cpp/probes.h>
#include </var/www/html/cpp/outlets.h>
#include </var/www/html/cpp/dcPorts.h>
#include </var/www/html/cpp/sensors.h>
#include </var/www/html/cpp/ds18b20.h>
// #include </var/www/html/cpp/dht22.h>
#include </var/www/html/cpp/lights.h>
#include </var/www/html/cpp/dosing.h>
#include </var/www/html/cpp/schedules.h>
#include </var/www/html/cpp/rules.h>
#include </var/www/html/cpp/socket.cpp>
// #include </var/www/html/cpp/TEST.cpp>


using namespace std;

void *socketLoop(void *threadid) {  // loop for socket to communicate with php
    while(1)
    {
        // sleep(1);
        checkCommunications();
    }
}
void *mainDS18B20Loop(void *threadid) {  // loop to check ds18b20 and pH circuits - thread 1
    while(1)
    {
        ds18b20.checkTemps();
        ds18b20.saveDS18B20Charts();
        ds18b20.checkDHT22();
        probes.checkProbes();
        probes.saveProbeCharts();
        i2c.scanI2Cbus();
        sleep(1);
    }
}
void *mainLoop(void *threadid) {  // main program loop - thread 0
    while(1)
    {
        // sleep(1);
        // currentMillis2 = std::chrono::duration_cast<std::chrono::milliseconds>(std::chrono::system_clock::now().time_since_epoch()).count();

        // currentMillisTime = currentMillisTime - 3120000;
        systemSettings.updateTime();
        // currentMillisTracker = millis();  // get current millis since program started
        // currentMillisTime = currentMillisLastSync + (currentMillisTracker - currentMillisOffset);  // 


        if (currentMillisTime >= (prevHealthMillis + 1000)) 
        {
            health = healthCount;
            healthCount = 0;
            // Jul 10, 2021 = 195 Health @ 5000 usleep
            // Sept 8, 2021 = 195 Health @ 5000 usleep
            // Sept 8, 2021 = 52705 Health without delay
            // std::cout << "health = " << health << endl;
            prevHealthMillis = currentMillisTime;
        }

        // if (currentMillisTime >= (prevMillisBlink + 1000)) 
        // {
        //     // std::cout << "-currentMillisTime  - " << currentMillisTime << std::endl;
        //     outlets.switchGPIO(11);
        //     outlets.switchGPIO(26);
        //     prevMillisBlink = currentMillisTime;
        // }

	    lights.monitorLightSchedules();
	    schedules.monitorSchedules();
        dosing.monitorDosingPumps();
        sensors.readSensors();
            rules.monitorRules();
        
        if (currentMillisTime >= (programStartMillis + 10000)) {  // wait 20 seconds after program starts to monitor custom rules
            if (currentMillisTime >= (prevUpdateMillis + 3600000))
            // if (currentMillisTime >= (prevUpdateMillis + 10000))
            {
                update.checkForUpdate(0);
                prevUpdateMillis = currentMillisTime;
            }
        }
        healthCount++;
        // delay(25);
        usleep(5000);

    }
}
pthread_t threads[3] = {};   // define number of threads to run

void startThreads(){  // setup multiple threads
    int rc = 0;
    int i = 0;
   
    // create thread 1 for main loop
    // std::cout << "main() : creating thread, " << 0 << endl;
    rc = pthread_create(&threads[0], NULL, mainLoop, (void *)0);

    if (rc) {
        // std::cout << "Error:unable to create thread," << rc << endl;
        exit(-1);
    }

    // create thread for ds18b20 and pH circuits
    // std::cout << "main() : creating thread, " << 1 << endl;
    rc = pthread_create(&threads[1], NULL, mainDS18B20Loop, (void *)1);

    if (rc) {
        // std::cout << "Error:unable to create thread," << rc << endl;
        exit(-1);
    }

    // create thread for socket to communicate with php
    // std::cout << "main() : creating thread, " << 2 << endl;
    rc = pthread_create(&threads[2], NULL, socketLoop, (void *)2);

    if (rc) {
        // std::cout << "Error:unable to create thread," << rc << endl;
        exit(-1);
    }
}

void smartStart()  // 
{
}

void setup()
{
	std::cout <<"Hello World" << endl;
    currentMillisTime = std::chrono::duration_cast<std::chrono::milliseconds>(std::chrono::system_clock::now().time_since_epoch()).count();
    std::cout << "-currentMillisTime     - " << currentMillisTime << std::endl;

    systemSettings.updateTime();
    programStartMillis = currentMillisTime;
    prevMillisBlink = currentMillisTime;

    // std::cout << "-currentMillisTime  - " << currentMillisTime << std::endl;
    std::cout << "-midnightMillis     - " << midnightMillis << std::endl;
    std::cout << "-nextMidnightMillis - " << nextMidnightMillis << std::endl;
    // std::cout << "-currentDay           - " << currentDay << std::endl;
    // std::cout << "-currentMonth         - " << currentMonth << std::endl;
    // std::cout << "-currentYear          - " << currentYear << std::endl;
    // std::cout << "-nextCurrentDay       - " << nextCurrentDay << std::endl;
    // std::cout << "-nextCurrentMonth     - " << nextCurrentMonth << std::endl;
    // std::cout << "-nextCurrentYear      - " << nextCurrentYear << std::endl;
    // std::cout << "currentWeekday = " << currentWeekday << endl;
    // std::cout << "seconds= " << timePtr->tm_sec << endl;
    // std::cout << "minutes = " << timePtr->tm_min << endl;
    // std::cout << "hours = " << timePtr->tm_hour << endl;
    // std::cout << "weekday = " << timePtr->tm_wday << endl;
    // std::cout << "day of year = " << timePtr->tm_yday << endl;
    // std::cout << "daylight savings = " << timePtr->tm_isdst << endl;

    // initiate wiringPi library
	if(wiringPiSetup()<0){
		// std::cout << "setup wiring pi failed"<<endl;
	}

    // listen to SIGINT, SIGTERM, and SIGKILL
    signal(SIGINT, signal_callback_handler);
    signal(SIGTERM, signal_callback_handler);
    signal(SIGKILL, signal_callback_handler);

    // setup socket address structure
    memset(&server_addr, 0, sizeof(server_addr));
    server_addr.sun_family = AF_UNIX;
    strcpy(server_addr.sun_path, SOCKET_FILENAME);

    server = socket(PF_UNIX, SOCK_STREAM, 0);  
    close(server);  // close stream if open
    unlink(SOCKET_FILENAME);
    // bind and listen on the socket file
    bind_listen_socket(server, server_addr);

    // allocate buffer
    socketBuflen = 1024;
    // socketBuf = new char[socketBuflen+1];

    startThreads();  // setup multiple threads
    // syncDateTimeStartup();

        MYSQL_RES *res;
        MYSQL_ROW row;

        connectMysql();
        std::string query = "SELECT tempCorF, timeFormat, outletSortID, dcSortID, supportID, updateRan FROM systemSettings WHERE userID = 1";  // check if temperature should be celcuis or fehrenheit
        mysql_query(conn, query.c_str());  // run query
        res = mysql_use_result(conn);

        while ((row = mysql_fetch_row(res)) != NULL)
        {
            ds18b20.updateTempCorF(atoi(row[0]));  // get temperature format
            // dht22.updateTempCorF(atoi(row[0]));  // get temperature format
            timeFormat = atoi(row[1]);  // get time format
            outlets.changeOutletSortID(atoi(row[2]));  // get outlet sortID
            dcPorts.changeDcSortID(atoi(row[3]));  // get DC port sortID
            supportID = atoi(row[4]);  // get supportID
            update.updateUpdateAvailable(atoi(row[5]));
        }
        mysql_free_result(res);
        mysql_disconnect(); 

    emails.startupEmails();
    emails.sendEmail("Robo-Tank was Restarted","Message from Robo-Tank Aquarium Controller");

    i2c.startupI2C();  // setup I2C devices
    i2c.scanI2Cbus();
    pca9685.startupPCA9685();
    // lightsSetup();
    // setupPinModes();
    outlets.startupACoutlets();
    dcPorts.startupDCports();
    dosing.startupDosing();
    ds18b20.startupDHT22();
    sensors.startupSensors();
    probes.startupProbes();  // run once when Pi starts

    // setPWMFreq(50);
    lights.readLightModes();
	lights.resumeLightMode();
    schedules.readSchedules();
    rules.startupRules();
    // std::cout << std::system("php -f /var/www/html/php/socketReconnect.php");  // run php script

    // create txt file for front end to find so it knows we c++ program is running again
    ofstream MyFile("/var/www/html/reconnected.txt");
    MyFile.close();

    if (supportID == 0) 
    {
        using u32    = uint_least32_t; 
        using engine = std::mt19937;

        std::random_device os_seed;
        const u32 seed = os_seed();

        engine generator(seed);
        std::uniform_int_distribution< u32 > distribute(1000000, 1316134911);

        supportID = distribute(generator);
        
        connectMysql();
        std::string query = "UPDATE systemSettings SET supportID = '" + to_string(supportID) + "' WHERE userID = 1";
        mysql_query(conn, query.c_str()); // run query
        mysql_disconnect(); 

        // std::cout << "supportID = " << supportID << std::endl;
    }

    startupComplete = 1;
    std::cout << "supportID           - " << supportID << std::endl;
    std::cout << "startupComplete     - " << startupComplete << std::endl;
    
    std::cout << "startupComplete     - " << millis() << std::endl;
    std::cout << "" << std::endl;
    std::cout << "" << std::endl;
    std::cout << "" << std::endl;
}

int main(void)//(int argc, char **argv)
{
	setup();  // main setup function
	while(1){
        sleep(1);
	}
}

