
using namespace std;

class sensors
{
    public:
        sensors();
        void startupSensors();  // run at startup
        void readSensors();  // continually read state of sensors
        short getStatus(short pinID);  // get status of sensor
    private:
        short sensorPinID[30] = {};  // unique  
        short sensorPin[30] = {};  // pin number
        short sensorDriver[30] = {};  // driverID
        short sensorStatus[30] = {};  // outlet status
        short sensorInvert[30] = {};  // track if logic is inverted
        short sensorTotal = 0;  // total sensors found
};
sensors::sensors(){}

short sensors::getStatus(short pinID) {  // get calRunning status
    short arrayID = 0;
    for(short a=0; a < sensorTotal; a++) {  //
        if (sensorPinID[a] == pinID) {arrayID = a; break;}
    }
    return sensorStatus[arrayID];
}

void sensors::readSensors() {  // continually read state of sensors
    for(short a=0; a < sensorTotal; a++) {  // read all sensors
        if (sensorDriver[a] == 2) {
            sensorStatus[a] = digitalRead(sensorPin[a]);
            // delay(10);
            if (sensorInvert[a] == 1) {
                if (sensorStatus[a] == 0) {sensorStatus[a] = 1;}
                else {sensorStatus[a] = 0;}
            }
        }
    }
            // cout << "sensorStatus     - " << sensorStatus[0] << std::endl;
            // cout << "sensorStatus     - " << sensorStatus[4] << std::endl;
    // delay(1000);
}

void sensors::startupSensors() {  // run at startup
    std::cout << " " << std::endl;
    std::cout << "startupSensors------------------------------" << std::endl;
    MYSQL_RES *res;
    MYSQL_ROW row;

    std::fill_n(sensorPinID, 30, 0);  // reset array
    std::fill_n(sensorDriver, 30, 0);  // reset array
    std::fill_n(sensorPin, 30, 0);  // reset array
    std::fill_n(sensorStatus, 30, 0);  // reset array
    std::fill_n(sensorInvert, 30, 0);  // reset array

    // Sensors
    connectMysql();
    std::string query = "SELECT pinID, driverID, wiringpi, invert FROM pinsAvailable WHERE pinTypeID = '6' OR pinTypeID = '7' OR pinTypeID = '8' OR pinTypeID = '9' AND assigned = 'Yes'";  // construct query string
    mysql_query(conn, query.c_str());  // run query

    res = mysql_use_result(conn);
    sensorTotal = 0;
    while ((row = mysql_fetch_row(res)) != NULL)
    {
        sensorPinID[sensorTotal] = atoi(row[0]);
        sensorDriver[sensorTotal] = atoi(row[1]);
        sensorPin[sensorTotal] = atoi(row[2]);
        sensorInvert[sensorTotal] = atoi(row[3]);
        pinMode(sensorPin[sensorTotal],INPUT);
        if (sensorDriver[sensorTotal] == 2) {sensorStatus[sensorTotal] = digitalRead(sensorPin[sensorTotal]);}
        cout << "wiringpi input     - " << sensorPinID[sensorTotal] << " - " << sensorPin[sensorTotal] << " - " << sensorDriver[sensorTotal] << std::endl;
        sensorTotal++;
    }
    mysql_disconnect(); 
    mysql_free_result(res);

    std::cout << "----------------------------------------" << std::endl;

}

sensors sensors;