
using namespace std;

class update
{
    public:
        update();
        void checkForUpdate(short manual);  // check if there's an update available
        void runUpdate();  // run update
        void updateRan();  // update ran
        void updateFinished();  // update finished
        void updateAutoUpdate(short update);  // update auto update
        void updateUpdateAvailable(short update);  // update auto update
        short getUpdateAvailable();  // get updateAvailable status for frontend
    private:
        float appVersion = 0.0;
        float versionAvailable = 0.0;
        std::string versionAvailableS = "";
        short autoUpdate = 0;
        short updateAvailable = 0;
        short supportUpdate = 0;
};
update::update(){}

short update::getUpdateAvailable() {  // get updateAvailable status for frontend
    return updateAvailable;
}

static size_t getAppVersion(void *contents, size_t size, size_t nmemb, void *userp) {  // extract Robo-Tank app version from web page
    ((std::string*)userp)->append((char*)contents, size * nmemb);
    return size * nmemb;
}

void update::updateRan() {  // update ran
    // std::cout << "" << std::endl;
    // std::cout << "" << std::endl;
    // std::cout << "updateRan --------------------------------- " << std::endl;
    // std::cout << "" << std::endl;
    // std::cout << "" << std::endl;

    updateAvailable = 3;
    if (supportUpdate == 0)  // normal update
    {
        appVersion = versionAvailable;
        connectMysql();
        std::string query = "UPDATE systemSettings SET version = '" + versionAvailableS + "' WHERE userID = 1";
        mysql_query(conn, query.c_str()); // run query
        mysql_disconnect(); 
    }
}

void update::updateFinished() {  // update finished
    // std::cout << "" << std::endl;
    // std::cout << "" << std::endl;
    // std::cout << "updateFinished --------------------------------- " << std::endl;
    // std::cout << "" << std::endl;
    // std::cout << "" << std::endl;

    updateAvailable = 0;
    connectMysql();
    std::string query = "UPDATE systemSettings SET updateRan = '0' WHERE userID = 1";
    mysql_query(conn, query.c_str()); // run query
    mysql_disconnect();
    
    if (supportUpdate == 1)  // support update
    {
        connectMysql();
        std::string query = "UPDATE systemSettings SET versionLatest = '" + to_string(appVersion) + "' WHERE userID = 1";
        mysql_query(conn, query.c_str()); // run query
        mysql_disconnect();
    }
}

void update::runUpdate() {  // run update
    if (updateAvailable == 1)
    {
        // std::cout << "Running Update --------------- " << std::endl;
        // std::cout << "supportUpdate    = " << supportUpdate << std::endl;
        if (supportUpdate == 0)  // normal update
        {
            checkForUpdate(1);  // check for any new updates before running
            delay(1000);
        }
        
        float totalUpdates = std::round((versionAvailable - appVersion) * 10);  // total updates needing to be installed
        float updating = appVersion;  // currently updating version x.x

        // std::cout << "totalUpdates = " << totalUpdates << std::endl;

        for(short a=0; a < totalUpdates; a++ )  // download and extract all updates to be installed
        {
            updating = updating + 0.1;  // increment to next update
            std::stringstream file;  // construct file\folder name
            file << "v_" << std::fixed << std::setprecision(1) << updating;  // round to 1 decimal place
            // std::cout << "updating     = " << updating << std::endl;
            // std::cout << "file         = " << file.str() << std::endl;
            // std::cout << "" << std::endl;
            // std::string comm = "cat /proc/cpuinfo | grep Serial | cut -d ' ' -f 2"

            std::string comm = "sudo rm -rf /var/www/html/updates/" + file.str();  // delete update folder and contents
            system(comm.c_str());

            comm = "sudo rm /var/www/html/updates/" + file.str() + ".zip";  // delete update folder and contents
            system(comm.c_str());

            comm = "sudo wget -c https://www.robo-tank.ca/app/updates/" + file.str() + ".zip -P /var/www/html/updates/";  // download update
            system(comm.c_str());

            comm = "sudo mkdir /var/www/html/updates/" + file.str();  // create new temporary folder for update
            system(comm.c_str());

            comm = "sudo unzip -o /var/www/html/updates/" + file.str() + ".zip -d /var/www/html/updates/";  // unzip update
            system(comm.c_str());
        
            comm = "sudo cp -r /var/www/html/updates/" + file.str() + "/* /var/www/html/";  // copy update files
            system(comm.c_str());

            delay(1000);
            
            // if (supportUpdate == 0)  // normal update
            // {
            //     if (updating == 6.1) {update_6_1();}
            // }
        }

        updating = appVersion;  // currently updating version x.x
        for(short a=0; a < totalUpdates; a++ )  // delete temporary files from updates
        {
            updating = updating + 0.1;  // increment to next update
            std::stringstream file;  // construct file\folder name
            file << "v_" << std::fixed << std::setprecision(1) << updating;  // round to 1 decimal place
            // std::cout << "updating     = " << updating << std::endl;
            // std::cout << "file         = " << file.str() << std::endl;
            // std::cout << "" << std::endl;

            std::string comm = "sudo rm -rf /var/www/html/updates/" + file.str();  // delete update folder and contents
            system(comm.c_str());

            comm = "sudo rm /var/www/html/updates/" + file.str() + ".zip";  // delete update folder and contents
            system(comm.c_str());
            delay(1000);
        }
        
        // std::cout << "" << std::endl;
        // std::cout << "" << std::endl;
        // std::cout << "Finished Update" << std::endl;
        // std::cout << "" << std::endl;
        // std::cout << "" << std::endl;

        delay(2000);
        updateAvailable = 2;
        connectMysql();
        std::string query = "UPDATE systemSettings SET updateRan = '" + to_string(updateAvailable) + "' WHERE userID = 1";
        mysql_query(conn, query.c_str()); // run query
        mysql_disconnect();
        
        std::string comm = "sudo reboot";  // reboot pi
        system(comm.c_str());
        // sudo wget -c https://www.robo-tank.ca/app/updates/6_11.zip -P /var/www/html/updates/
        // sudo wget -c https://www.robo-tank.ca/app/updates/6_11.zip
        // sudo unzip reef-pi_install_files.zip
        // sudo bash install_reefpi.sh
        // sudo rm -rf 6.1

    }
}

void update::checkForUpdate(short manual) {  // check if there's an update available
    // std::cout << " " << std::endl;
    // std::cout << "checkForUpdate------------------------------" << std::endl;
    MYSQL_RES *res;
    MYSQL_ROW row;

    connectMysql();
    std::string query = "SELECT autoUpdate, version FROM systemSettings WHERE userID = 1";  // check if temperature should be celcuis or fehrenheit
    mysql_query(conn, query.c_str());  // run query

    res = mysql_use_result(conn);
    while ((row = mysql_fetch_row(res)) != NULL)
    {
        autoUpdate = atoi(row[0]);
        appVersion = atof(row[1]);
    }
    mysql_disconnect(); 
    mysql_free_result(res);
    // std::cout << "autoUpdate = " << autoUpdate << std::endl;

    if ((autoUpdate == 1) || (manual == 1))  // auto or manual
    {
        CURL *curl;
        curl = curl_easy_init();
        if(curl) 
        {
            versionAvailableS = "";
            curl_easy_setopt(curl, CURLOPT_URL, "https://www.robo-tank.ca/app/version.html");
            curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, getAppVersion);
            curl_easy_setopt(curl, CURLOPT_WRITEDATA, &versionAvailableS);

            try {
                curl_easy_perform(curl);

                try {versionAvailable = std::stof(versionAvailableS);}  // latest version available
                catch(invalid_argument& e) {}

                // std::cout << "" << std::endl;
                // std::cout << "" << std::endl;
                // std::cout << "Robo-Tank Version = " << appVersion << std::endl;
                // std::cout << "Robo-Tank Version Available = " << versionAvailable << std::endl;
                // std::cout << "Robo-Tank Version Available = " << versionAvailableS << std::endl;
                // std::cout << "" << std::endl;

                // std::string supportUpdate = versionAvailableS.at(0);
                unsigned support = versionAvailableS.find("s");
                // std::cout << "support    = " << support << std::endl;
                
                if (support == 0)  // support update
                {
                    supportUpdate = 1;
                    unsigned first = versionAvailableS.find("_");
                    unsigned last = versionAvailableS.find_last_of("_");
                    std::string id = versionAvailableS.substr (first+1,last-(first+1));
                    // std::cout << id << std::endl;
                    if (supportID == stoi(id))  // check if update belongs to this controller
                    {
                        // std::cout << "ID Matched ------------------- " << std::endl;
                        updateAvailable = 1;

                        unsigned last = versionAvailableS.find_last_of("_");
                        std::string ver = versionAvailableS.substr(last+1);

                        versionAvailable = std::stof(ver);  // latest version available
                        versionAvailableS = ver;  // latest version available
                        // std::cout << "Robo-Tank Version    = " << appVersion << std::endl;
                        // std::cout << "versionAvailableS    = " << versionAvailableS << std::endl;
                        // std::cout << "versionAvailable     = " << versionAvailable << std::endl;

                        connectMysql();
                        std::string query = "UPDATE systemSettings SET versionLatest = '" + versionAvailableS + "' WHERE userID = 1";
                        mysql_query(conn, query.c_str()); // run query
                        mysql_disconnect();
                    }
                }
                else  // normal update
                {
                    supportUpdate = 0;
                    if (versionAvailable >= 6) {
                        if (versionAvailable != appVersion) {
                            // std::cout << "Update Available" << std::endl;
                            updateAvailable = 1;
                            connectMysql();
                            std::string query = "UPDATE systemSettings SET versionLatest = '" + versionAvailableS + "' WHERE userID = 1";
                            mysql_query(conn, query.c_str()); // run query
                            mysql_disconnect(); 
                        }
                        else {
                            // std::cout << "Up to Date" << std::endl;
                            updateAvailable = 0;
                        }
                    }
                }
                // std::cout << "" << std::endl;
            }
            catch(bad_alloc& e)
            {
                cerr<<"Robo-Tank Update Failed: "<<e.what() << endl;
                while(1){
                    sleep(1);
                }
            }

            curl_easy_cleanup(curl);  // cleanup
        }
    }

    // std::cout << "----------------------------------------" << std::endl;
}

void update::updateAutoUpdate(short update) {  // update auto update
    // std::cout << "updateAutoUpdate = " << update << std::endl;
    autoUpdate = update;

    connectMysql();
    std::string query = "UPDATE systemSettings SET autoUpdate = '" + to_string(autoUpdate) + "' WHERE userID = 1";
    mysql_query(conn, query.c_str()); // run query
    mysql_disconnect();

    if (autoUpdate == 0) {checkForUpdate(1);}
}

void update::updateUpdateAvailable(short update) {  // update auto update
    updateAvailable = update;
    // std::cout << "updateAvailable START = " << updateAvailable << std::endl;
}

update update;