
var lightModeSlider = [];
var movingSliderCh = 255;
var editingModeNumber = 255;
var editingPinID = 255;
var slidersDrawn = [];  // track if sliders have been drawn to screen so we don't get duplicates
var enableButtonPressed = 0;  // track if enable light mode button is pressed
var lightStartTimeEdit = [];  // used to track unconverted hours, converted hours, minutes and seconds when editing schedule
var lightEndTimeEdit = [];  // used to track unconverted hours, converted hours, minutes and seconds when editing schedule

function updateNextLightDashboard() {  //
    var dt = new Date();
    var secs = dt.getSeconds() + (60 * (dt.getMinutes() + (60 * dt.getHours())));

    if (displayScreen == 0) {
        for (var i=0; i < lightModeNumber.length; i++) {  // get current schedule number
            if (lightCurrentScheduleID == lightModeID[i]) {
                document.getElementById('lightModeName').innerHTML = lightModeName[i]; break;
            }
        }

        for (var i=0; i < lightModeNumber.length; i++) {  // get next schedule number
            if (lightNextScheduleID == lightModeID[i]) {
                // console.log('lightModeStart             = ' + lightModeStart[i]);
                document.getElementById('lightModeLabel').innerHTML = lightModeName[i];
                document.getElementById('lightModeNext').innerHTML = secondsToTime(lightModeStart[i] - secs); break;
            }
        }
    }
}

function printLightWidget() {  // runs from firstRun.js

    // console.log('printLightWidget-----------');
    // console.log('lightCurrentSchedule       = ' + lightCurrentSchedule);
    // console.log('lightCurrentScheduleID     = ' + lightCurrentScheduleID);
    // console.log('lightNextScheduleID        = ' + lightNextScheduleID);
    // console.log('lightCurrentScheduleNumber = ' + lightCurrentScheduleNumber);

    document.getElementById('contentCol2_Col1').innerHTML += 
    '<div class="dashboardLightMode" id="dashboardLightMode">\
        <div class="lightModeName" id="lightModeName"></div>\
        <div class="lightModeBox">\
            <div class="lightModeIcon">\
                <img class="" src="images/icons/moon/moon14.png">\
            </div>\
            <div class="lightModeInfo">\
                <div class="lightModeLabel" id="lightModeLabel"></div>\
                <div class="lightModeLabel">starting in</div>\
                <div class="lightModeLabel" id="lightModeNext">is coming in</div>\
            </div>\
        </div>\
    </div>';

    updateNextLightDashboard();
    // viewLightModes();  // default screen
}

function printCurrentMode() {  // current mode widget tab
    // console.log('printCurrentMode------');
    $('.lightsWidgetBoxContainer').empty();
    
    document.getElementById('lightsWidgetBoxContainer').innerHTML += 
        '<div class="lightAquarium" onclick="printLightSliders()"></div>';
    document.getElementById('lightsWidgetBoxContainer').innerHTML += '<div id="lightCase" onclick="printLightSliders()"></div>';
    for (var i = 0; i < lightAssigned.length; i++)  // 
    {
        document.getElementById('lightCase').innerHTML += 
            '<div id="lightBeam' + i + '" class="lightBeam"></div>';
    }

    var size = (lightAssigned.length * 60) + 90;

    document.documentElement.style.setProperty('--tank-w1', size + "px");
    document.documentElement.style.setProperty('--tank-w2', size - 90 + "px");
    // console.log('lightNextScheduleID = ' + lightNextScheduleID);
    // console.log('lightCurrentScheduleID = ' + lightCurrentScheduleID);

    var ch = 0;
    for (var i = 0; i < lightModePinID.length; i++)  // draw sliders to screen
    {
        if (lightDetailModeID[i] == lightCurrentScheduleID)
        {
            // console.log('lightModeID[lightCurrentSchedule]         = ' + lightCurrentScheduleID);
            // console.log('lightModeLightLevel[lightCurrentSchedule] = ' + lightModeLightLevel[i]);
            updateLightAnimation(lightModeLightLevel[i],ch);
            ch++;
        }
    }
}

function printSliders(modeI, modeN)  // print sliders to screen
{
    // console.log('printSliders------');
    // console.log(lightDetailModeID);
    // console.log(lightModePinID);
    // console.log(lightModeLightLevel);
    // console.log(lightPinID);
    // console.log(lightName);
    // console.log(modeI);
    // editingModeID = modeI;
    // document.getElementById('modesButton').style.backgroundColor = "rgb(80, 80, 80)";  // update guage
    var sliderArray = 0;
    
    if (slidersDrawn[modeN] != 1) {
        var ch = 0;
        document.getElementById("modeContent_" + modeN).innerHTML = "";
        for (var i = 0; i < lightModePinID.length; i++)  // draw sliders to screen
        {
            if (lightDetailModeID[i] == modeI)
            {
                // console.log("modeI = " + modeI);
                document.getElementById("modeContent_" + modeN).innerHTML +=  // 
                    '<div class="lightsWidgetBox">\
                        <div class="verticalSliderName">' + lightName[ch] + '</div>\
                        <div class="verticalSliderBox"><input data-slider-id="ledSliders" type="text" onchange="moveSlider(' + sliderArray + ',' + modeN + ',' + lightPinID[ch] + ')" data-slider-value="' + lightModeLightLevel[i] + '" id="ch' + sliderArray + modeN + '"/></div>\
                        <div class="verticalSliderValue"><input class="verticalSliderTextbox" type="text" id="chValue' + sliderArray + modeN + '" onchange="editSliderValue(' + sliderArray + ',' +  modeN + ',' + lightPinID[ch] + ')" value="' + lightModeLightLevel[i] + '"></div>\
                    </div>';
                
                // console.log("sliderArray  = " + sliderArray);
                sliderArray++;
                ch++;
            }
        }

        sliderArray = 0;
        for (var i = 0; i < lightModePinID.length; i++)  // define bootstrap-slider for each slider
        {
            if (lightDetailModeID[i] == modeI)
            {
                // console.log("sliderArray2 = " + sliderArray);
                lightModeSlider[sliderArray] = new Slider("#ch" + sliderArray + modeN, {  // setup slider options
                    reversed : true,
                    orientation : 'vertical',
                    step : 1,
                    min : 0,
                    max : 4095
                });
                lightModeSlider[sliderArray].on("slideStop", function() {  // when slider is released make sure last value is sent to backend
                    // stopSlider();
                    setTimeout(stopSlider, 200);  // save updated slider value
                });
                sliderArray++;
            }
        }
        slidersDrawn[modeN] = 1;
    }
}

function stopSlider(){  // when slider is released make sure last value is sent to backend
    // console.log("stopSlider");
    // console.log(movingSliderCh);
    // console.log(editingModeNumber);
    // console.log(editingPinID);
    // console.log(lightModeSlider[movingSliderCh].getValue());
    
    var command = "11," + editingModeNumber + "," + editingPinID + "," + lightModeSlider[movingSliderCh].getValue();
    // console.log('stopSlider------ ' + command);
    sendToBackend(command);  // send slider value to backend
    document.getElementById("chValue" + movingSliderCh + editingModeNumber).value = lightModeSlider[movingSliderCh].getValue();
    
    var newLevel = 0;
    for (var i = 0; i < lightModePinID.length; i++)  // draw sliders to screen
    {
        if (lightDetailModeID[i] == lightModeID[editingModeNumber])
        {
            if (lightModePinID[i] == editingPinID)
            {
                // console.log("modeID = " + lightModeID[editingModeNumber]);
                // console.log("before = " + lightModeLightLevel[i]);
                lightModeLightLevel[i] = lightModeSlider[movingSliderCh].getValue().toString();
                // console.log("after  = " + lightModeLightLevel[i]);
                newLevel = lightModeLightLevel[i];
            }
        }
    }
    updateLightAnimation(movingSliderCh);
    setTimeout(function(){
        stopSendingData = 0;  // resume communcations after 1 seconds
    }, 1000);
    // printSliders(lightModeID[editingModeNumber],editingModeNumber);
}

function moveSlider(ch, modeN, pinID){  // update slider when moved
    // console.log("ch = " + ch);
    // console.log("lightModeSlider = " + lightModeSlider[ch].getValue());
    stopSendingData = 100;  // pause communcations
    movingSliderCh = ch;
    editingModeNumber = modeN;
    editingPinID = pinID;
    var command = "1," + modeN + "," + pinID + "," + lightModeSlider[ch].getValue();
    // console.log('moveSlider------ ' + command);
    sendToBackend(command);  // send slider value to backend
    // console.log('moveSlider------ ' + command);
    // console.log("chValue" + ch + modeN);
    // console.log("chValue = " + lightModeSlider[ch].getValue());
    document.getElementById("chValue" + ch + modeN).value = lightModeSlider[ch].getValue();
    // updateLightAnimation(i);
}

function editSliderValue(ch, modeN, pinID){  // update slider when text box is used
    movingSliderCh = ch;
    editingModeNumber = modeN;
    editingPinID = pinID;
    // console.log("editingModeNumber = " + editingModeNumber);
    lightModeSlider[ch].setValue(document.getElementById("chValue" + ch + modeN).value);
    var command = "11," + modeN + "," + pinID + "," + lightModeSlider[ch].getValue();
    // console.log('editSliderValue------ ' + command);
    sendToBackend(command);  // send slider value to backend
    // updateLightAnimation(ch);
    stopSlider(ch);
}

function getNextLightModeScheduled() {  // draw orange and green background checkmark for current and next schedule
    $.ajax({
        url: "/php/lightsGetNextSchedule.php",
        method: "GET",
        cache: false,
        success: function(dataWindow) {
            // console.log('getNextLightModeScheduled-----------');
            data = JSON.parse(dataWindow);
            for(var i in data) {
                // place list of outlets in individual variables
                lightNextSchedule = (data[i].nextLightSchedule);
                lightCurrentSchedule = (data[i].currentLightSchedule);
            }
            lightCurrentScheduleID = lightCurrentSchedule.slice(9);
            lightNextScheduleID = lightNextSchedule.slice(9);

            if (lightCurrentSchedule != 0) 
            {
                // var cDay = lightCurrentSchedule.slice(5,8);  // extract current day from string example, Tue
                // var nDay = lightNextSchedule.slice(5,8);  // extract next day from string example, Wed
                // console.log('cDay                   = ' + cDay);
                // console.log('nDay                   = ' + nDay);
                // console.log('lightCurrentSchedule   = ' + lightCurrentSchedule);
                
                for (var i=0; i < lightModeNumber.length; i++) {  // get current schedule number
                    if (lightCurrentScheduleID == lightModeID[i]) {lightCurrentScheduleNumber = lightModeNumber[i]; break;}
                }
                     
            }
            if (lightNextSchedule != 0)
            {
                // console.log('lightNextSchedule      = ' + lightNextSchedule);
                for (var i=0; i < lightModeNumber.length; i++) {  // get next schedule number
                    if (lightNextScheduleID == lightModeID[i]) {lightNextScheduleNumber = lightModeNumber[i]; break;}
                }
                // console.log('lightNextScheduleNumber      = ' + lightNextScheduleNumber);
                
            }
            // console.log('lightNextSchedule = ' + lightNextSchedule);
            // if (lightNextSchedule != "") document.getElementById(lightNextSchedule).style.color = "rgb(0, 0, 0)";
            
            // console.log('lightCurrentSchedule   = ' + lightCurrentSchedule);
            // console.log('lightNextSchedule      = ' + lightNextSchedule);

            
            // console.log('lightCurrentScheduleID = ' + lightCurrentScheduleID);
            // console.log('lightNextScheduleID = ' + lightNextScheduleID);
        },
        error: function(dataWindow) {
            console.log(dataWindow);
            console.log('error - getNextLightModeScheduled');
        }
    });

}

function viewLightModes() {  // light modes widget tab - sorted by mode number

    printHeaderTitle("LIGHT MODES", "lights_sm.png");  // name and file
    removeFooter();
    
    document.getElementById('content').innerHTML +=
        "<div class='cleanScreen'>\
                <div class='lightsWidgetBoxContainer' id='lightsWidgetBoxContainer'></div>\
        </div>";

    // document.getElementById('footerContainer').innerHTML +=
    //     '<div class="buttons">\
    //         <button class="button" type="button" onclick="loadLayout()">Cancel</button>\
    //     </div>';
    
    slidersDrawn = [];  // empty array that tracks sliders as they need to be redrawn after sorting modes
    $('.lightsWidgetBoxContainer').empty();

    document.getElementById('lightsWidgetBoxContainer').innerHTML +=  // draw light mode table header
    '<div class="lightModesListContainer">\
        <div class="lightModesList" id="lightModesListBox">\
            <div class="lightModesListTableHeader">\
                <div class="lightModesListTable4">&nbsp</div>\
                <div class="lightModesListTable4">#</div>\
                <div class="lightModesListTable2">Name</div>\
                <div class="lightModesListTable3">Start</div>\
                <div class="lightModesListTable3">End</div>\
                <div class="lightModesListTable5">\
                    <div class="lightModesListTable4">&nbsp</div>\
                    <div class="lightModesListTable4">&nbsp</div>\
                    <div class="lightModesListTable4">&nbsp</div>\
                    <div class="lightModesListTable4">&nbsp</div>\
                    <div class="lightModesListTable4">&nbsp</div>\
                    <div class="lightModesListTable1"> \
                        <div class="lightModesListTable8">S</div>\
                        <div class="lightModesListTable8">S</div>\
                        <div class="lightModesListTable8">F</div>\
                        <div class="lightModesListTable8">T</div>\
                        <div class="lightModesListTable8">W</div>\
                        <div class="lightModesListTable8">T</div>\
                        <div class="lightModesListTable8">M</div>\
                    </div>\
                </div>\
            </div>\
            <ul class="lightModesListTable" id="lightModesList">';

    for (var i=0; i < lightModeNumber.length; i++)  // draw each light mode to list
    {
        // console.log("lightModeStart[i] = " + lightModeStart[i]);
        var convertedStart = secondsToTime(lightModeStart[i]);
        var convertedEnd = secondsToTime(lightModeEnd[i]);
        var start = tConvert(convertedStart);  // convert mode start time to 12hr format if necessary
        var end = tConvert(convertedEnd);  // convert to mode end time to 12hr format if necessary

        document.getElementById('lightModesList').innerHTML +=  // draw row in list for each mode
                '<li class="collapsible" id="lightModeList' + i + '">\
                    <div class="lightModesListTable4" id="expandIcon_' + lightModeNumber[i] + '" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">\
                        <div class="lightModesListIcon bi bi-arrow-90deg-down" title="View Mode Details" style="font-size:8px; margin-left:8px;"></div>\
                    </div>\
                    <div class="lightModesListTable4" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">' + lightModeNumber[i] + '</div>\
                    <div class="lightModesListTable2" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">' + lightModeName[i] + '</div>\
                    <div class="lightModesListTable3" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">' + start + '</div>\
                    <div class="lightModesListTable3" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">' + end + '</div>\
                    <div class="lightModesListTable5">\
                        <div class="lightModesListTable4">\
                            <div onclick="moveLightMode(1,' + lightModeNumber[i] + ')" class="lightModesListIcon bi bi-arrow-down-short" data-toggle="tooltip" data-placement="bottom" title="Move Mode Down" style="font-size:18px"></div>\
                        </div>\
                        <div class="lightModesListTable4">\
                            <div onclick="moveLightMode(0,' + lightModeNumber[i] + ')" class="lightModesListIcon bi bi-arrow-up-short" title="Move Mode Up" style="font-size:18px"></div>\
                        </div>\
                        <div class="lightModesListTable4">\
                            <div onclick="confirmDeleteLightMode(' + lightModeNumber[i] + ')" class="lightModesListIcon bi bi-x-circle-fill" title="Delete Mode" style="font-size:13px"></div>\
                        </div>\
                        <div class="lightModesListTable4">\
                            <div onclick="editLightMode(' + lightModeNumber[i] + ')" class="lightModesListIcon bi bi-pencil-fill" title="Edit Mode" style="font-size:13px"></div>\
                        </div>\
                        <div class="lightModesListTable4" style="margin-right:7px;" id="enable_' + lightModeNumber[i] + '" title="Enable/Disable Mode"></div>\
                        <div class="lightModesListTable1"> \
                            <div class="lightModesListTable8" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">\
                                <div class="lightModesListIcon" id="lightSun_' + lightModeID[i] + '" data-toggle="tooltip" data-placement="bottom" title="" style="font-size:15px"></div>\
                            </div>\
                            <div class="lightModesListTable8" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">\
                                <div class="lightModesListIcon" id="lightSat_' + lightModeID[i] + '" data-toggle="tooltip" data-placement="bottom" title="" style="font-size:15px"></div>\
                            </div>\
                            <div class="lightModesListTable8" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">\
                                <div class="lightModesListIcon" id="lightFri_' + lightModeID[i] + '" data-toggle="tooltip" data-placement="bottom" title="" style="font-size:15px"></div>\
                            </div>\
                            <div class="lightModesListTable8" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">\
                                <div class="lightModesListIcon" id="lightThu_' + lightModeID[i] + '" data-toggle="tooltip" data-placement="bottom" title="" style="font-size:15px"></div>\
                            </div>\
                            <div class="lightModesListTable8" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">\
                                <div class="lightModesListIcon" id="lightWed_' + lightModeID[i] + '" data-toggle="tooltip" data-placement="bottom" title="" style="font-size:15px"></div>\
                            </div>\
                            <div class="lightModesListTable8" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">\
                                <div class="lightModesListIcon" id="lightTue_' + lightModeID[i] + '" data-toggle="tooltip" data-placement="bottom" title="" style="font-size:15px"></div>\
                            </div>\
                            <div class="lightModesListTable8" onclick="expandLightMode(' + lightModeNumber[i] + ',' + lightModeID[i] + ')">\
                                <div class="lightModesListIcon" id="lightMon_' + lightModeID[i] + '" data-toggle="tooltip" data-placement="bottom" title="" style="font-size:15px"></div>\
                            </div>\
                        </div>\
                    </div>\
                </li>\
                <div class="modeContent" id="modeContent_' + lightModeNumber[i] + '">\
                </div>\
            </div>';
    }
    document.getElementById('lightsWidgetBoxContainer').innerHTML += 
            '</ul>\
        </div">\
        <div style="width:100%; text-align:center; margin-top:12px;"><p>Click on a light mode to adjust the light levels.</p>\
        <p>If you exit this page with a mode expanded the lights will remain in that mode and won\'t fade.</p>\
        <p>If you exit this page with all modes collapsed the lights will be in automatic mode and dim according to the modes.</p></div>\
        <div class="widgetButtonBox" style="margin-top:-15px;">\
            <button class="button _48 add_48" style="margin-top:40px;" type="button" onclick="addLightMode()"></button>\
            <button class="button _48 home_48" style="margin-top:40px;" type="button" onclick="loadLayout()"></button>\
        </div>';  // close off list

    for (var i=0; i < lightModeNumber.length; i++)  // add enabled/disabled toggle switch to each item in list
    {
        if (lightModeEnabled[i] == 1) {
            document.getElementById('enable_' + lightModeNumber[i]).innerHTML = 
                '<div id="enableButton_' + lightModeNumber[i] + '" onclick="enableLightMode(' + lightModeNumber[i] + ')" class="lightModesListIcon bi bi-toggle-on" style="font-size:20px; color:#00b610;"></div>';
                
            document.getElementById('lightMon_' + lightModeID[i]).style.color = 'rgb(0, 0, 0)';  // 
            document.getElementById('lightTue_' + lightModeID[i]).style.color = 'rgb(0, 0, 0)';  // 
            document.getElementById('lightWed_' + lightModeID[i]).style.color = 'rgb(0, 0, 0)';  // 
            document.getElementById('lightThu_' + lightModeID[i]).style.color = 'rgb(0, 0, 0)';  // 
            document.getElementById('lightFri_' + lightModeID[i]).style.color = 'rgb(0, 0, 0)';  // 
            document.getElementById('lightSat_' + lightModeID[i]).style.color = 'rgb(0, 0, 0)';  // 
            document.getElementById('lightSun_' + lightModeID[i]).style.color = 'rgb(0, 0, 0)';  // 

            if (lightModeMon[i] == 1) {document.getElementById('lightMon_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightMon_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeTue[i] == 1) {document.getElementById('lightTue_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightTue_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeWed[i] == 1) {document.getElementById('lightWed_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightWed_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeThu[i] == 1) {document.getElementById('lightThu_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightThu_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeFri[i] == 1) {document.getElementById('lightFri_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightFri_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeSat[i] == 1) {document.getElementById('lightSat_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightSat_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeSun[i] == 1) {document.getElementById('lightSun_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightSun_' + lightModeID[i]).innerHTML = '&nbsp';}  // 
        }
        else {
            document.getElementById('enable_' + lightModeNumber[i]).innerHTML = 
                '<div id="enableButton_' + lightModeNumber[i] + '" onclick="enableLightMode(' + lightModeNumber[i] + ')" class="lightModesListIcon bi bi-toggle-off" style="font-size:20px; color:rgb(50, 50, 50);"></div>';

            document.getElementById('lightMon_' + lightModeID[i]).style.color = 'rgb(200, 200, 200)';  // 
            document.getElementById('lightTue_' + lightModeID[i]).style.color = 'rgb(200, 200, 200)';  // 
            document.getElementById('lightWed_' + lightModeID[i]).style.color = 'rgb(200, 200, 200)';  // 
            document.getElementById('lightThu_' + lightModeID[i]).style.color = 'rgb(200, 200, 200)';  // 
            document.getElementById('lightFri_' + lightModeID[i]).style.color = 'rgb(200, 200, 200)';  // 
            document.getElementById('lightSat_' + lightModeID[i]).style.color = 'rgb(200, 200, 200)';  // 
            document.getElementById('lightSun_' + lightModeID[i]).style.color = 'rgb(200, 200, 200)';  // 
            
            if (lightModeMon[i] == 1) {document.getElementById('lightMon_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightMon_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeTue[i] == 1) {document.getElementById('lightTue_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightTue_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeWed[i] == 1) {document.getElementById('lightWed_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightWed_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeThu[i] == 1) {document.getElementById('lightThu_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightThu_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeFri[i] == 1) {document.getElementById('lightFri_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightFri_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeSat[i] == 1) {document.getElementById('lightSat_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightSat_' + lightModeID[i]).innerHTML = '&nbsp';}  // 

            if (lightModeSun[i] == 1) {document.getElementById('lightSun_' + lightModeID[i]).className = 'lightModesListIcon bi bi-check2';}  // 
            else {document.getElementById('lightSun_' + lightModeID[i]).innerHTML = '&nbsp';}  // 
        }

        document.getElementById('lightMon_' + lightModeID[i]).title = 'Scheduled';  // 
        document.getElementById('lightTue_' + lightModeID[i]).title = 'Scheduled';  // 
        document.getElementById('lightWed_' + lightModeID[i]).title = 'Scheduled';  // 
        document.getElementById('lightThu_' + lightModeID[i]).title = 'Scheduled';  // 
        document.getElementById('lightFri_' + lightModeID[i]).title = 'Scheduled';  // 
        document.getElementById('lightSat_' + lightModeID[i]).title = 'Scheduled';  // 
        document.getElementById('lightSun_' + lightModeID[i]).title = 'Scheduled';  // 
    }

    setTimeout(getNextLightModeScheduled, 1000);  // get next light mode schedule, wait for 
    

    $( function() {  // enable list sorting for light mode table
        $( "#lightModesList" ).sortable({
            placeholder: "ui-state-highlight",
            distance: 1000,  // set drag amount high so it doesn't work
            scrollSensitivity: 100, 
            scrollSpeed: 2,
            tolerance: "intersect"
        });
        $( "#lightModesList" ).disableSelection();
    } );
}

function tempLightModes() {  // temporary modes widget tab
    slidersDrawn = [];  // empty array that tracks sliders as they need to be redrawn after sorting modes
    $('.lightsWidgetBoxContainer').empty();
    document.getElementById('lightsWidgetBoxContainer').innerHTML += 'Temporary light modes coming soon...';
}

function lightGetStartHMS(value) {  // convert seconds to hours, minutes and seconds so we can edit schedule time easy
    // console.log('convertHMS        = ' + value); 
    const sec = parseInt(value, 10); // convert value to number
    lightStartTimeEdit[0] = Math.floor(sec / 3600); // get hours
    lightStartTimeEdit[2] = Math.floor((sec - (lightStartTimeEdit[0] * 3600)) / 60); // get minutes
    lightStartTimeEdit[3] = sec - (lightStartTimeEdit[0] * 3600) - (lightStartTimeEdit[2] * 60); //  get seconds
    
    lightConvertStartHour();

    if (lightStartTimeEdit[2] < 10) {lightStartTimeEdit[2] = "0"+ lightStartTimeEdit[2];}  // add 0 in front of minutes if needed
    if (lightStartTimeEdit[3] < 10) {lightStartTimeEdit[3] = "0" + lightStartTimeEdit[3];}  // add 0 in front of seconds if needed

    // console.log(lightStartTimeEdit[0] + " - " + lightStartTimeEdit[1] + ":" + lightStartTimeEdit[2] + ":" + lightStartTimeEdit[3]); 
}

function lightConvertStartHour() {
    // console.log('lightStartTimeEdit[0]  = ' + lightStartTimeEdit[0]); 
    if ((timeFormat == 1) && (lightStartTimeEdit[0] == 0)) lightStartTimeEdit[1] = 12 + "am";  // convert 24hr to 12hr 
    else if ((timeFormat == 1) && (lightStartTimeEdit[0] == 12)) {lightStartTimeEdit[1] = lightStartTimeEdit[0] + "pm";}  // convert 24hr to 12hr
    else if ((timeFormat == 1) && (lightStartTimeEdit[0] > 12)) {lightStartTimeEdit[1] = (lightStartTimeEdit[0] - 12) + "pm";}  // convert 24hr to 12hr
    else if (timeFormat == 1) {lightStartTimeEdit[1] = lightStartTimeEdit[0] + "am";}  // no need to convert
    else if (timeFormat == 0) {lightStartTimeEdit[1] = lightStartTimeEdit[0];}  // no need to convert

    if ((timeFormat == 0) && (lightStartTimeEdit[0] < 10)) {lightStartTimeEdit[1] = "0"+lightStartTimeEdit[0];}  // add 0 in front of hours if needed
}

function lightConvertEditStartTime(modeN) {  // convert time format to seconds
    // console.log(lightStartTimeEdit[0] + ":" + lightStartTimeEdit[2] + ":" + lightStartTimeEdit[3]); 
    // console.log('lightModeStart[modeN] = ' + lightModeStart[modeN]); 
    var time = lightStartTimeEdit[0] + ":" + lightStartTimeEdit[2] + ":" + lightStartTimeEdit[3]; 
    lightModeStart[modeN] = secondsFromTime(time);
    // console.log('lightModeStart[modeN] = ' + lightModeStart[modeN]); 
}

function lightStartTimeUp(type) {
    // console.log('lightStartTimeUp     = ' + type);
    if (type == 0) {  // hours
        lightStartTimeEdit[0]++;
        if (lightStartTimeEdit[0] > 23) {lightStartTimeEdit[0] = 0;}
        lightConvertStartHour();
        document.getElementById('lightStartHour').innerHTML = lightStartTimeEdit[1]; // draw screen        
    }
    else if (type == 1) {  // minutes
        lightStartTimeEdit[2]++;
        if (lightStartTimeEdit[2] > 59) {lightStartTimeEdit[2] = 0;}
        if (lightStartTimeEdit[2] < 10) {lightStartTimeEdit[2] = "0"+ lightStartTimeEdit[2];}  // add 0 in front of minutes if needed
        document.getElementById('lightStartMinute').innerHTML = lightStartTimeEdit[2]; // draw screen  
    }
    else if (type == 2) {  // seconds
        lightStartTimeEdit[3]++;
        if (lightStartTimeEdit[3] > 59) {lightStartTimeEdit[3] = 0;}
        if (lightStartTimeEdit[3] < 10) {lightStartTimeEdit[3] = "0"+ lightStartTimeEdit[3];}  // add 0 in front of minutes if needed
        document.getElementById('lightStartSecond').innerHTML = lightStartTimeEdit[3]; // draw screen  
    }
}

function lightStartTimeDown(type) {
    // console.log('lightStartTimeDown   = ' + type); 
    if (type == 0) {  // hours
        lightStartTimeEdit[0]--;
        if (lightStartTimeEdit[0] < 0) {lightStartTimeEdit[0] = 23;}
        lightConvertStartHour();
        document.getElementById('lightStartHour').innerHTML = lightStartTimeEdit[1]; // draw screen        
    }
    else if (type == 1) {  // minutes
        lightStartTimeEdit[2]--;
        if (lightStartTimeEdit[2] < 0) {lightStartTimeEdit[2] = 59;}
        if (lightStartTimeEdit[2] < 10) {lightStartTimeEdit[2] = "0"+ lightStartTimeEdit[2];}  // add 0 in front of minutes if needed
        document.getElementById('lightStartMinute').innerHTML = lightStartTimeEdit[2]; // draw screen  
    }
    else if (type == 2) {  // seconds
        lightStartTimeEdit[3]--;
        if (lightStartTimeEdit[3] < 0) {lightStartTimeEdit[3] = 59;}
        if (lightStartTimeEdit[3] < 10) {lightStartTimeEdit[3] = "0"+ lightStartTimeEdit[3];}  // add 0 in front of minutes if needed
        document.getElementById('lightStartSecond').innerHTML = lightStartTimeEdit[3]; // draw screen  
    }
}

function lightGetEndHMS(value) {  // convert seconds to hours, minutes and seconds so we can edit schedule time easy
    // console.log('convertHMS        = ' + value); 
    const sec = parseInt(value, 10); // convert value to number
    lightEndTimeEdit[0] = Math.floor(sec / 3600); // get hours
    lightEndTimeEdit[2] = Math.floor((sec - (lightEndTimeEdit[0] * 3600)) / 60); // get minutes
    lightEndTimeEdit[3] = sec - (lightEndTimeEdit[0] * 3600) - (lightEndTimeEdit[2] * 60); //  get seconds
    
    lightConvertEndHour();

    if (lightEndTimeEdit[2] < 10) {lightEndTimeEdit[2] = "0"+ lightEndTimeEdit[2];}  // add 0 in front of minutes if needed
    if (lightEndTimeEdit[3] < 10) {lightEndTimeEdit[3] = "0" + lightEndTimeEdit[3];}  // add 0 in front of seconds if needed

    // console.log(lightEndTimeEdit[0] + " - " + lightEndTimeEdit[1] + ":" + lightEndTimeEdit[2] + ":" + lightEndTimeEdit[3]); 
}

function lightConvertEndHour() {
    // console.log('lightEndTimeEdit[0]  = ' + lightEndTimeEdit[0]); 
    if ((timeFormat == 1) && (lightEndTimeEdit[0] == 0)) lightEndTimeEdit[1] = 12 + "am";  // convert 24hr to 12hr 
    else if ((timeFormat == 1) && (lightEndTimeEdit[0] == 12)) {lightEndTimeEdit[1] = lightEndTimeEdit[0] + "pm";}  // convert 24hr to 12hr
    else if ((timeFormat == 1) && (lightEndTimeEdit[0] > 12)) {lightEndTimeEdit[1] = (lightEndTimeEdit[0] - 12) + "pm";}  // convert 24hr to 12hr
    else if (timeFormat == 1) {lightEndTimeEdit[1] = lightEndTimeEdit[0] + "am";}  // no need to convert
    else if (timeFormat == 0) {lightEndTimeEdit[1] = lightEndTimeEdit[0];}  // no need to convert

    if ((timeFormat == 0) && (lightEndTimeEdit[0] < 10)) {lightEndTimeEdit[1] = "0"+lightEndTimeEdit[0];}  // add 0 in front of hours if needed
}

function lightConvertEditEndTime(modeN) {  // convert time format to seconds
    // console.log(lightEndTimeEdit[0] + ":" + lightEndTimeEdit[2] + ":" + lightEndTimeEdit[3]); 
    // console.log('lightModeEnd[modeN] = ' + lightModeEnd[modeN]); 
    var time = lightEndTimeEdit[0] + ":" + lightEndTimeEdit[2] + ":" + lightEndTimeEdit[3]; 
    lightModeEnd[modeN] = secondsFromTime(time);
    // console.log('lightModeEnd[modeN] = ' + lightModeEnd[modeN]); 
}

function lightEndTimeUp(type) {
    // console.log('lightEndTimeUp     = ' + type);
    if (type == 0) {  // hours
        lightEndTimeEdit[0]++;
        if (lightEndTimeEdit[0] > 23) {lightEndTimeEdit[0] = 0;}
        lightConvertEndHour();
        document.getElementById('lightEndHour').innerHTML = lightEndTimeEdit[1]; // draw screen        
    }
    else if (type == 1) {  // minutes
        lightEndTimeEdit[2]++;
        if (lightEndTimeEdit[2] > 59) {lightEndTimeEdit[2] = 0;}
        if (lightEndTimeEdit[2] < 10) {lightEndTimeEdit[2] = "0"+ lightEndTimeEdit[2];}  // add 0 in front of minutes if needed
        document.getElementById('lightEndMinute').innerHTML = lightEndTimeEdit[2]; // draw screen  
    }
    else if (type == 2) {  // seconds
        lightEndTimeEdit[3]++;
        if (lightEndTimeEdit[3] > 59) {lightEndTimeEdit[3] = 0;}
        if (lightEndTimeEdit[3] < 10) {lightEndTimeEdit[3] = "0"+ lightEndTimeEdit[3];}  // add 0 in front of minutes if needed
        document.getElementById('lightEndSecond').innerHTML = lightEndTimeEdit[3]; // draw screen  
    }
}

function lightEndTimeDown(type) {
    // console.log('lightEndTimeDown   = ' + type); 
    if (type == 0) {  // hours
        lightEndTimeEdit[0]--;
        if (lightEndTimeEdit[0] < 0) {lightEndTimeEdit[0] = 23;}
        lightConvertEndHour();
        document.getElementById('lightEndHour').innerHTML = lightEndTimeEdit[1]; // draw screen        
    }
    else if (type == 1) {  // minutes
        lightEndTimeEdit[2]--;
        if (lightEndTimeEdit[2] < 0) {lightEndTimeEdit[2] = 59;}
        if (lightEndTimeEdit[2] < 10) {lightEndTimeEdit[2] = "0"+ lightEndTimeEdit[2];}  // add 0 in front of minutes if needed
        document.getElementById('lightEndMinute').innerHTML = lightEndTimeEdit[2]; // draw screen  
    }
    else if (type == 2) {  // seconds
        lightEndTimeEdit[3]--;
        if (lightEndTimeEdit[3] < 0) {lightEndTimeEdit[3] = 59;}
        if (lightEndTimeEdit[3] < 10) {lightEndTimeEdit[3] = "0"+ lightEndTimeEdit[3];}  // add 0 in front of minutes if needed
        document.getElementById('lightEndSecond').innerHTML = lightEndTimeEdit[3]; // draw screen  
    }
}

function editLightMode(modeN) {  // draw edit light mode screen
    slidersDrawn = [];  // empty array that tracks sliders as they need to be redrawn after sorting modes
    $('.lightsWidgetBoxContainer').empty();
    
    lightGetStartHMS(lightModeStart[modeN]);
    lightGetEndHMS(lightModeEnd[modeN]);

    document.getElementById('lightsWidgetBoxContainer').innerHTML +=  // draw screen
        '<div class="daysContainer">\
            <div class="settingsHeader">Edit Light Mode</div>\
            <div class="ruleOptionBox" style="margin-bottom:10px; padding-bottom:15px;">\
                <div class="label" style="padding-right:5px;">Light Mode Name</div>\
                <input class="field" type="text" id="mName" value="' + lightModeName[modeN] + '" autocomplete="off">\
                <div class="fieldError" id="fieldError"></div>\
            </div>\
            <div class="ruleOptionBox">\
                <div class="settingsTitle">Light Mode Starts At</div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Hour</div>\
                        <div class="parameterValue" id="lightStartHour">' + lightStartTimeEdit[1] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp0" onmousedown="lightStartTimeUp(0)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown0" onmousedown="lightStartTimeDown(0)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Minute</div>\
                        <div class="parameterValue" id="lightStartMinute">' + lightStartTimeEdit[2] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp1" onmousedown="lightStartTimeUp(1)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown1" onmousedown="lightStartTimeDown(1)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Second</div>\
                        <div class="parameterValue" id="lightStartSecond">' + lightStartTimeEdit[3] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp2" onmousedown="lightStartTimeUp(2)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown2" onmousedown="lightStartTimeDown(2)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
            </div>\
            <div class="ruleOptionBox">\
                <div class="settingsTitle">Light Mode Ends At</div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Hour</div>\
                        <div class="parameterValue" id="lightEndHour">' + lightEndTimeEdit[1] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp3" onmousedown="lightEndTimeUp(0)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown3" onmousedown="lightEndTimeDown(0)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Minute</div>\
                        <div class="parameterValue" id="lightEndMinute">' + lightEndTimeEdit[2] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp4" onmousedown="lightEndTimeUp(1)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown4" onmousedown="lightEndTimeDown(1)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Second</div>\
                        <div class="parameterValue" id="lightEndSecond">' + lightEndTimeEdit[3] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp5" onmousedown="lightEndTimeUp(2)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown5" onmousedown="lightEndTimeDown(2)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
            </div>\
        </div>\
        <div class="daysContainer">\
            <div class="days">\
                <label for="monday">Monday </label>\
                <input type="checkbox" id="monday" onclick="changeModeDay(0,' + modeN + ')">\
            </div>\
            <div class="days">\
                <label for="tuesday">Tuesday </label>\
                <input type="checkbox" id="tuesday" onclick="changeModeDay(1,' + modeN + ')">\
            </div>\
            <div class="days">\
                <label for="wednesday">Wednesday</label>\
                <input type="checkbox" id="wednesday" onclick="changeModeDay(2,' + modeN + ')">\
            </div>\
            <div class="days">\
                <label for="thursday">Thursday</label>\
                <input type="checkbox" id="thursday" onclick="changeModeDay(3,' + modeN + ')">\
            </div>\
            <div class="days">\
                <label for="friday">Friday</label>\
                <input type="checkbox" id="friday" onclick="changeModeDay(4,' + modeN + ')">\
            </div>\
            <div class="days">\
                <label for="saturday">Saturday</label>\
                <input type="checkbox" id="saturday" onclick="changeModeDay(5,' + modeN + ')">\
            </div>\
            <div class="days">\
                <label for="sunday">Sunday</label>\
                <input type="checkbox" id="sunday" onclick="changeModeDay(6,' + modeN + ')">\
            </div>\
        </div>\
        <br>\
        <div class="widgetButtonBox">\
            <button class="button _wide" type="button" onclick="saveLightMode(' + modeN + ',document.getElementById(\'mName\').value)">Save</button>\
            <button class="button _48 back_48" type="button" onclick="cancelLightMode()"></button>\
        </div>';
    
    if (lightModeMon[modeN] == '1') {
        document.getElementById('monday').checked = true;
    }
    if (lightModeTue[modeN] == '1') {
        document.getElementById('tuesday').checked = true;
    }
    if (lightModeWed[modeN] == '1') {
        document.getElementById('wednesday').checked = true;
    }
    if (lightModeThu[modeN] == '1') {
        document.getElementById('thursday').checked = true;
    }
    if (lightModeFri[modeN] == '1') {
        document.getElementById('friday').checked = true;
    }
    if (lightModeSat[modeN] == '1') {
        document.getElementById('saturday').checked = true;
    }
    if (lightModeSun[modeN] == '1') {
        document.getElementById('sunday').checked = true;
    }

    var timer;  // used to track setInverval so it can be cleared
    $('#lightButtonUp0').mousedown(function(){
        timer = setInterval(function() { lightStartTimeUp(0); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp1').mousedown(function(){
        timer = setInterval(function() { lightStartTimeUp(1); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp2').mousedown(function(){
        timer = setInterval(function() { lightStartTimeUp(2); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown0').mousedown(function(){
        timer = setInterval(function() { lightStartTimeDown(0); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown1').mousedown(function(){
        timer = setInterval(function() { lightStartTimeDown(1); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown2').mousedown(function(){
        timer = setInterval(function() { lightStartTimeDown(2); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp3').mousedown(function(){
        timer = setInterval(function() { lightEndTimeUp(0); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp4').mousedown(function(){
        timer = setInterval(function() { lightEndTimeUp(1); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp5').mousedown(function(){
        timer = setInterval(function() { lightEndTimeUp(2); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown3').mousedown(function(){
        timer = setInterval(function() { lightEndTimeDown(0); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown4').mousedown(function(){
        timer = setInterval(function() { lightEndTimeDown(1); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown5').mousedown(function(){
        timer = setInterval(function() { lightEndTimeDown(2); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
}

function changeModeDay(day,modeN) {  // change days for light modes
    // console.log('changeModeDay------ ' + day + ' - ' + modeN);
    switch (day) {
        case 0:
            // console.log('case 0------ ' + day + ' - ' + modeN);
            if (lightModeMon[modeN] == '1') {
                lightModeMon[modeN] = '0'
                document.getElementById('monday').checked = false;
            }
            else {
                lightModeMon[modeN] = '1'
                document.getElementById('monday').checked = true;
            }
        break;
        
        case 1:
            // console.log('case 1------ ' + day + ' - ' + modeN);
            if (lightModeTue[modeN] == '1') {
                lightModeTue[modeN] = '0'
                document.getElementById('tuesday').checked = false;
            }
            else {
                lightModeTue[modeN] = '1'
                document.getElementById('tuesday').checked = true;
            }
        break;
        
        case 2:
            if (lightModeWed[modeN] == '1') {
                lightModeWed[modeN] = '0'
                document.getElementById('wednesday').checked = false;
            }
            else {
                lightModeWed[modeN] = '1'
                document.getElementById('wednesday').checked = true;
            }
        break;
        
        case 3:
            if (lightModeThu[modeN] == '1') {
                lightModeThu[modeN] = '0'
                document.getElementById('thursday').checked = false;
            }
            else {
                lightModeThu[modeN] = '1'
                document.getElementById('thursday').checked = true;
            }
        break;
        
        case 4:
            if (lightModeFri[modeN] == '1') {
                lightModeFri[modeN] = '0'
                document.getElementById('friday').checked = false;
            }
            else {
                lightModeFri[modeN] = '1'
                document.getElementById('friday').checked = true;
            }
        break;
        
        case 5:
            if (lightModeSat[modeN] == '1') {
                lightModeSat[modeN] = '0'
                document.getElementById('saturday').checked = false;
            }
            else {
                lightModeSat[modeN] = '1'
                document.getElementById('saturday').checked = true;
            }
        break;
        
        case 6:
            if (lightModeSun[modeN] == '1') {
                lightModeSun[modeN] = '0'
                document.getElementById('sunday').checked = false;
            }
            else {
                lightModeSun[modeN] = '1'
                document.getElementById('sunday').checked = true;
            }
        break;
    }
}

function addLightMode() {  // draws add new light mode screen
    slidersDrawn = [];  // empty array that tracks sliders as they need to be redrawn after sorting modes
    $('.lightsWidgetBoxContainer').empty();

    // console.log("addLightMode ----- ");
    // console.log("lightModeNumber ----- " + lightModeNumber.length);

    var newModeNumber = lightModeNumber.length;  // generate new mode number
    if (lightModeName[newModeNumber] == undefined) lightModeName[newModeNumber] = "";  // if mode name is undefined clear array location so placeholder label appears
    
    lightGetStartHMS(0);
    lightGetEndHMS(0);

    document.getElementById('lightsWidgetBoxContainer').innerHTML += // draw screen
        '<div class="daysContainer">\
            <div class="settingsHeader">Add New Light Mode</div>\
            <div class="ruleOptionBox" style="margin-bottom:10px; padding-bottom:15px;">\
                <div class="fieldName">Light Mode Name</div>\
                <input class="field" type="text" id="mName" value="' + lightModeName[newModeNumber] + '" placeholder="Enter light mode name..." autocomplete="off">\
                <div class="fieldError" id="fieldError"></div><br>\
            </div>\
            <div class="ruleOptionBox">\
                <div style="width:100%; text-align:center; font-weight:bold; font-size:16px; margin-bottom:10px;">Light Mode Starts At</div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Hour</div>\
                        <div class="parameterValue" id="lightStartHour">' + lightStartTimeEdit[1] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp0" onmousedown="lightStartTimeUp(0)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown0" onmousedown="lightStartTimeDown(0)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Minute</div>\
                        <div class="parameterValue" id="lightStartMinute">' + lightStartTimeEdit[2] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp1" onmousedown="lightStartTimeUp(1)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown1" onmousedown="lightStartTimeDown(1)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Second</div>\
                        <div class="parameterValue" id="lightStartSecond">' + lightStartTimeEdit[3] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp2" onmousedown="lightStartTimeUp(2)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown2" onmousedown="lightStartTimeDown(2)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
            </div>\
            <div class="ruleOptionBox">\
                <div style="width:100%; text-align:center; font-weight:bold; font-size:16px; margin-bottom:10px;">Light Mode Ends At</div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Hour</div>\
                        <div class="parameterValue" id="lightEndHour">' + lightEndTimeEdit[1] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp3" onmousedown="lightEndTimeUp(0)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown3" onmousedown="lightEndTimeDown(0)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Minute</div>\
                        <div class="parameterValue" id="lightEndMinute">' + lightEndTimeEdit[2] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp4" onmousedown="lightEndTimeUp(1)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown4" onmousedown="lightEndTimeDown(1)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
                <div class="parameterBox">\
                    <div class="parameterInfoBox">\
                        <div class="parameterTitle">Second</div>\
                        <div class="parameterValue" id="lightEndSecond">' + lightEndTimeEdit[3] + '</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="lightButtonUp5" onmousedown="lightEndTimeUp(2)" class="upDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="lightButtonDown5" onmousedown="lightEndTimeDown(2)" class="upDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
            </div>\
        </div>\
        <div class="daysContainer">\
            <div class="days">\
                <label for="monday">Monday </label>\
                <input type="checkbox" id="monday" onclick="changeModeDay(0,' + newModeNumber + ')">\
            </div>\
            <div class="days">\
                <label for="tuesday">Tuesday </label>\
                <input type="checkbox" id="tuesday" onclick="changeModeDay(1,' + newModeNumber + ')">\
            </div>\
            <div class="days">\
                <label for="wednesday">Wednesday</label>\
                <input type="checkbox" id="wednesday" onclick="changeModeDay(2,' + newModeNumber + ')">\
            </div>\
            <div class="days">\
                <label for="thursday">Thursday</label>\
                <input type="checkbox" id="thursday" onclick="changeModeDay(3,' + newModeNumber + ')">\
            </div>\
            <div class="days">\
                <label for="friday">Friday</label>\
                <input type="checkbox" id="friday" onclick="changeModeDay(4,' + newModeNumber + ')">\
            </div>\
            <div class="days">\
                <label for="saturday">Saturday</label>\
                <input type="checkbox" id="saturday" onclick="changeModeDay(5,' + newModeNumber + ')">\
            </div>\
            <div class="days">\
                <label for="sunday">Sunday</label>\
                <input type="checkbox" id="sunday" onclick="changeModeDay(6,' + newModeNumber + ')">\
            </div>\
        </div>\
        <br>\
        <div class="widgetButtonBox">\
            <button class="button _wide" type="button" onclick="saveNewLightMode(' + newModeNumber + ',document.getElementById(\'mName\').value)">Save</button>\
            <button class="button _48 back_48" type="button" onclick="cancelLightMode()"></button>\
        </div>';

    lightModeMon[newModeNumber] = '1';
    document.getElementById('monday').checked = true;

    lightModeTue[newModeNumber] = '1';
    document.getElementById('tuesday').checked = true;

    lightModeWed[newModeNumber] = '1';
    document.getElementById('wednesday').checked = true;

    lightModeThu[newModeNumber] = '1';
    document.getElementById('thursday').checked = true;

    lightModeFri[newModeNumber] = '1';
    document.getElementById('friday').checked = true;

    lightModeSat[newModeNumber] = '1';
    document.getElementById('saturday').checked = true;

    lightModeSun[newModeNumber] = '1';
    document.getElementById('sunday').checked = true;
    
    // track mouse up/down when changing schedule time
    var timer;  // used to track setInverval so it can be cleared
    $('#lightButtonUp0').mousedown(function(){
        timer = setInterval(function() { lightStartTimeUp(0); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp1').mousedown(function(){
        timer = setInterval(function() { lightStartTimeUp(1); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp2').mousedown(function(){
        timer = setInterval(function() { lightStartTimeUp(2); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown0').mousedown(function(){
        timer = setInterval(function() { lightStartTimeDown(0); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown1').mousedown(function(){
        timer = setInterval(function() { lightStartTimeDown(1); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown2').mousedown(function(){
        timer = setInterval(function() { lightStartTimeDown(2); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp3').mousedown(function(){
        timer = setInterval(function() { lightEndTimeUp(0); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp4').mousedown(function(){
        timer = setInterval(function() { lightEndTimeUp(1); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonUp5').mousedown(function(){
        timer = setInterval(function() { lightEndTimeUp(2); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown3').mousedown(function(){
        timer = setInterval(function() { lightEndTimeDown(0); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown4').mousedown(function(){
        timer = setInterval(function() { lightEndTimeDown(1); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
    $('#lightButtonDown5').mousedown(function(){
        timer = setInterval(function() { lightEndTimeDown(2); }, 150);  // run continually while mouse down
    }).mouseup(function() {
        clearInterval(timer);
    }).mouseout(function() {
        clearInterval(timer);
    });
}

function saveLightMode(modeN,mName) {  // save updated light mode to database
    if ((mName == null) || (mName == "")) {  // check if password is blank.    
        // console.log('TRY AGAIN------ ');
        fieldError.style.display = "inline-block";  // show error
        document.getElementById('fieldError').innerHTML = "You need a name for the light mode!";
        document.getElementById('mName').style.border = "2px solid rgb(255, 0, 0)";
        document.getElementById("mName").focus();
    }
    else {
        $('.lightsWidgetBoxContainer').empty();

        lightConvertEditEndTime(modeN);
        lightConvertEditStartTime(modeN);
        // update variables
        lightModeName[modeN] = mName;
        // lightModeStart[modeN] = secondsFromTime(mStart);
        // lightModeEnd[modeN] = secondsFromTime(mEnd);

        var days = lightModeMon[modeN] + "," + lightModeTue[modeN] + "," + lightModeWed[modeN] + "," + lightModeThu[modeN] + "," + lightModeFri[modeN] + "," + lightModeSat[modeN] + "," + lightModeSun[modeN];

        viewLightModes();  // reload light mode screen
        var command = "8," + modeN + "," + lightModeStart[modeN] + "," + lightModeEnd[modeN] + "," + lightModeName[modeN] + "," + days;
        sendToBackend(command);
        // console.log('saveLightMode------ ' + command);
        // console.log('saveLightMode------days ' + days);
        setTimeout(getNextLightModeScheduled, 1000);  // get next light mode schedule, wait for 
    }
}

function saveNewLightMode(modeN,mName) {  // save new light mode to database
    // console.log('saveNewLightMode = ' + modeN);
    if ((mName == null) || (mName == "")) {  // check if password is blank.
        // console.log('TRY AGAIN------ ');
        fieldError.style.display = "inline-block";  // show error
        document.getElementById('fieldError').innerHTML = "You need a name for the light mode!";
        document.getElementById('mName').style.border = "2px solid rgb(255, 0, 0)";
        document.getElementById("mName").focus();
    }
    else {
        $('.lightsWidgetBoxContainer').empty();

        lightConvertEditEndTime(modeN);
        lightConvertEditStartTime(modeN);

        // console.log('saveNewLightMode------ ');
        // console.log('mStart------ ' + mStart);
        // console.log('mStart------ ' + mEnd);
        // update variables
        lightModeNumber[modeN] = modeN;
        lightModeName[modeN] = mName;
        // lightModeStart[modeN] = secondsFromTime(mStart);
        // lightModeEnd[modeN] = secondsFromTime(mEnd);
        // lightModeStart[modeN] = mStart;
        // lightModeEnd[modeN] = mEnd;
        lightModeEnabled[modeN] = 1;

        var days = lightModeMon[modeN] + "," + lightModeTue[modeN] + "," + lightModeWed[modeN] + "," + lightModeThu[modeN] + "," + lightModeFri[modeN] + "," + lightModeSat[modeN] + "," + lightModeSun[modeN];

        setTimeout(getLightModes, 200);  // wait 1000ms for results to come back from database
        // setTimeout(getLightModeDetails, 200);  // wait 1000ms for results to come back from database
        setTimeout(viewLightModes, 500);  // wait 1000ms for results to come back from database
        var command = "7," + modeN + "," + lightModeStart[modeN] + "," + lightModeEnd[modeN] + "," + lightModeName[modeN] + "," + days;
        sendToBackend(command);
        // console.log('saveNewLightMode------ ' + command);
        setTimeout(getNextLightModeScheduled, 1000);  // get next light mode schedule, wait for 
    }
}

function confirmDeleteLightMode(modeN) {  // open delete confirmation window
    $('.ds18b20Popup-body').empty();
    $('#popupBackground').show();  // grey out background
    ds18b20Popup.style.display = "block";
    document.querySelector("body").style.overflow = 'hidden';

    $('.ds18b20PopupHeader').empty();
    $(".ds18b20PopupHeader").append("Delete Light Mode");

    $(".ds18b20Popup-body").append(
        '<div style="text-align: center;"><p>&nbsp;</p>\
            <p>Are you sure you want to delete light mode "' + lightModeName[modeN] + '"?</p>\
            <div class="widgetButtonBox">\
                <button class="button _wide" type="button" onclick="deleteLightMode(`' + modeN + '`)">Yes</button>\
                <button class="button _wide" type="button" onclick="closeDs18b20Popup()">No</button>\
            </div>\
        </div>');
}

function deleteLightMode(modeN) {  // delete light mode from database
    slidersDrawn = [];  // empty array that tracks sliders as they need to be redrawn after sorting modes
    var command = "6, " + modeN;
    sendToBackend(command);  // tell backend to delete light mode
    // console.log('deleteLightMode------ ' + command);

    closeDs18b20Popup();  // close popup
    $('#popupBackground').hide();  // hide greyed out background
    setTimeout(getLightModes, 200);  // get light modes from database
    // setTimeout(getLightModeDetails, 300);  // wait 1000ms for results to come back from database
    setTimeout(renumberLightModes, 400);  // renumber light modes
    setTimeout(viewLightModes, 500);  // refresh light mode list
    setTimeout(getNextLightModeScheduled, 1000);  // get next light mode schedule, wait for 
}

function renumberLightModes() {  // renumber light modes
    for (var i = 0; i < lightModeNumber.length; i++) {  // send order of all widgets to database
        lightModeNumber[i] = i;  // change light mode number 
    }
}

function enableLightMode(modeN) {  // save enable/disable option to database and update icon
    if (enableButtonPressed == 0) {  // add 1000ms delay after button is pressed
        if (lightModeEnabled[modeN] == 0) {  // enable
            lightModeEnabled[modeN] = 1;
            document.getElementById('enable_' + modeN).innerHTML = 
                '<div id="enableButton_' + lightModeNumber[modeN] + '" onclick="enableLightMode(' + modeN + ')" class="lightModesListIcon bi bi-toggle-on" style="font-size:20px; color:#00b610;"></div>'
                
            if (lightModeMon[modeN] == 1) {
                document.getElementById('lightMon_' + lightModeID[modeN]).style.color = 'rgb(0, 0, 0)';  // 
                document.getElementById('lightMon_' + lightModeID[modeN]).title = 'Scheduled';  // 
            }
            if (lightModeTue[modeN] == 1) {
                document.getElementById('lightTue_' + lightModeID[modeN]).style.color = 'rgb(0, 0, 0)';  // 
                document.getElementById('lightTue_' + lightModeID[modeN]).title = 'Scheduled';  // 
            }
            if (lightModeWed[modeN] == 1) {
                document.getElementById('lightWed_' + lightModeID[modeN]).style.color = 'rgb(0, 0, 0)';  // 
                document.getElementById('lightWed_' + lightModeID[modeN]).title = 'Scheduled';  // 
            }
            if (lightModeThu[modeN] == 1) {
                document.getElementById('lightThu_' + lightModeID[modeN]).style.color = 'rgb(0, 0, 0)';  // 
                document.getElementById('lightThu_' + lightModeID[modeN]).title = 'Scheduled';  // 
            }
            if (lightModeFri[modeN] == 1) {
                document.getElementById('lightFri_' + lightModeID[modeN]).style.color = 'rgb(0, 0, 0)';  // 
                document.getElementById('lightFri_' + lightModeID[modeN]).title = 'Scheduled';  // 
            }
            if (lightModeSat[modeN] == 1) {
                document.getElementById('lightSat_' + lightModeID[modeN]).style.color = 'rgb(0, 0, 0)';  // 
                document.getElementById('lightSat_' + lightModeID[modeN]).title = 'Scheduled';  // 
            }
            if (lightModeSun[modeN] == 1) {
                document.getElementById('lightSun_' + lightModeID[modeN]).style.color = 'rgb(0, 0, 0)';  // 
                document.getElementById('lightSun_' + lightModeID[modeN]).title = 'Scheduled';  // 
            }
        }
        else {  // disable
            lightModeEnabled[modeN] = 0;
            document.getElementById('enable_' + modeN).innerHTML = 
                '<div id="enableButton_' + lightModeNumber[modeN] + '" onclick="enableLightMode(' + modeN + ')" class="lightModesListIcon bi bi-toggle-off" style="font-size:20px; color:rgb(50, 50, 50);"></div>'
                

            if (lightModeMon[modeN] == 1) {
                document.getElementById('lightMon_' + lightModeID[modeN]).style.color = 'rgb(200, 200, 200)';  // 
                document.getElementById('lightMon_' + lightModeID[modeN]).title = 'Disabled';  // 
            }
            if (lightModeTue[modeN] == 1) {
                document.getElementById('lightTue_' + lightModeID[modeN]).style.color = 'rgb(200, 200, 200)';  // 
                document.getElementById('lightTue_' + lightModeID[modeN]).title = 'Disabled';  // 
            }
            if (lightModeWed[modeN] == 1) {
                document.getElementById('lightWed_' + lightModeID[modeN]).style.color = 'rgb(200, 200, 200)';  // 
                document.getElementById('lightWed_' + lightModeID[modeN]).title = 'Disabled';  // 
            }
            if (lightModeThu[modeN] == 1) {
                document.getElementById('lightThu_' + lightModeID[modeN]).style.color = 'rgb(200, 200, 200)';  // 
                document.getElementById('lightThu_' + lightModeID[modeN]).title = 'Disabled';  // 
            }
            if (lightModeFri[modeN] == 1) {
                document.getElementById('lightFri_' + lightModeID[modeN]).style.color = 'rgb(200, 200, 200)';  // 
                document.getElementById('lightFri_' + lightModeID[modeN]).title = 'Disabled';  // 
            }
            if (lightModeSat[modeN] == 1) {
                document.getElementById('lightSat_' + lightModeID[modeN]).style.color = 'rgb(200, 200, 200)';  // 
                document.getElementById('lightSat_' + lightModeID[modeN]).title = 'Disabled';  // 
            }
            if (lightModeSun[modeN] == 1) {
                document.getElementById('lightSun_' + lightModeID[modeN]).style.color = 'rgb(200, 200, 200)';  // 
                document.getElementById('lightSun_' + lightModeID[modeN]).title = 'Disabled';  // 
            }
        }

        var command = "10," + modeN + "," + lightModeEnabled[modeN];
        sendToBackend(command);
        // console.log('enableLightMode------ ' + command);
        setTimeout(getNextLightModeScheduled, 500);  // get next light mode schedule, wait for 
        enableButtonPressed = 1;
        setTimeout(function(){enableButtonPressed = 0;},100);  // button can't be pressed again for 1000 millis
    }
}

function cancelLightMode() {  // cancel edit or new light mode
    viewLightModes();  // reload light mode screen
}

function moveLightMode(direction, modeN) {  // move light mode up or down in list
    // Array.prototype.move = function (from, to) {  // sort array
    //     this.splice(to, 0, this.splice(from, 1)[0]);
    // };
    if (enableButtonPressed == 0) {  // add 1000ms delay after button is pressed
        var newLocation = 0;

        if (direction == 0) newLocation = modeN - 1;  // move up
        else newLocation = modeN + 1;  // move down

        if ((newLocation >= 0) && (newLocation < lightModeNumber.length)) {  // check if we aren't moving 1st item up
            slidersDrawn = [];  // empty array that tracks sliders as they need to be redrawn after sorting modes
            // lightModeNumber.move(modeN,newLocation);  // move mode
            var command = "9," + direction + "," + modeN;
            sendToBackend(command);  // tell backend to save updated light mode number
            // console.log('moveLightMode------ ' + command);

            setTimeout(getLightModes, 200);  // wait 1000ms for results to come back from database
            // setTimeout(getLightModeDetails, 200);  // wait 1000ms for results to come back from database
            setTimeout(viewLightModes, 500);  // wait 1000ms for results to come back from database
        }
        enableButtonPressed = 1;
        setTimeout(function(){enableButtonPressed = 0;},1000);  // button can't be pressed again for 1000 millis
    }
}

function expandLightMode(modeN, modeI) {  // expand light mode on list and show sliders
    // show or hide light mode content block
    // console.log('expandLightMode------');
    // console.log(modeN);
    
    slidersDrawn = [];  // empty array that tracks sliders as they need to be redrawn after sorting modes
    if (document.getElementById('modeContent_' + modeN).style.display === "block") {  // collapse content
        var command = "15,";
        sendToBackend(command);  // send to backend
        document.getElementById('lightModeList' + modeN).style.backgroundColor = "rgb(255, 255, 255)";  // change row background to white
        document.getElementById('lightModeList' + modeN).style.color = "rgb(0, 0, 0)";  // change text color to black
        document.getElementById('modeContent_' + modeN).style.marginBottom = "0px";  // remove bottom margin
        document.getElementById('modeContent_' + modeN).style.display = "none";  // collapse content
        document.getElementById('expandIcon_' + modeN).innerHTML =  // change collapse icon
            '<div class="lightModesListIcon bi bi-arrow-90deg-down" style="margin-left:8px; font-size:11px"></div>'
    }
    else {  // expand content
        var command = "2," + modeN;
        sendToBackend(command);  // send to backend
        // console.log('expandLightMode------ ' + command);
        
        document.getElementById('lightModeList' + modeN).style.backgroundColor = "#00b610";  // change row background to green
        document.getElementById('lightModeList' + modeN).style.color = "rgb(255, 255, 255)";  // change text color to white
        // document.getElementById('modeContent_' + modeN).style.marginBottom = "15px";  // add top margin
        document.getElementById('modeContent_' + modeN).style.display = "block";  // expand content
        document.getElementById('expandIcon_' + modeN).innerHTML =  // change collapse icon
            '<div class="lightModesListIcon bi bi-arrow-90deg-up" style="margin-left:8px; font-size:11px; color:#FFFFFF"></div>'
        printSliders(modeI, modeN);
    } 
    for (var i=0; i < lightModeNumber.length; i++)  // close sliders being viewed for new for selection
    {
        if (i != modeN) {
            document.getElementById('lightModeList' + i).style.backgroundColor = "rgb(255, 255, 255)";  // change row background to white
            document.getElementById('lightModeList' + i).style.color = "rgb(0, 0, 0)";  // change text color to black
            document.getElementById('modeContent_' + i).style.marginBottom = "0px";  // remove bottom margin
            document.getElementById('modeContent_' + i).style.display = "none";  // collapse content
            document.getElementById('expandIcon_' + i).innerHTML =  // change collapse icon
                '<div class="lightModesListIcon bi bi-arrow-90deg-down" style="margin-left:8px; font-size:11px"></div>'
        }
    }
}

function updateLightAnimation(i,ch){  
    
    var percentage = (((i - 0) / (4095 - 0)) * 100);
    // var percentage = 25;
    var output = 1;
    if (percentage < 1.0)
    {
        // slope = (output_end - output_start) / (input_end - input_start)
        // output = output_start + slope * (input - input_start)
        var slope = (10 - 2) / (1 - 0);
        output = 2 + slope * (percentage - 0);
    }
    else if (percentage < 5)
    {
        var slope = (22 - 8) / (5 - 0);
        output = 8 + slope * (percentage - 0);
    }
    else if (percentage < 25)
    {
        var slope = (40 - 20) / (25 - 0);
        output = 20 + slope * (percentage - 0);
    }
    else if (percentage < 50)
    {   
        var slope = (45 - 36) / (50 - 0);
        output = 36 + slope * (percentage - 0);
    }
    else
    {   
        var slope = (50 - 40) / (100 - 0);
        output = 40 + slope * (percentage - 0);
    }

    // var output = 0 + ((100 - 0) / (50 - 30)) * (percentage - 30);
    // console.log("slope     : " + slope);
    // console.log("output    : " + output);
    // console.log("percentage: " + percentage);
    // console.log("i: " + i);
    // console.log(output);
    // var output = output_start + ((output_end - output_start) / (input_end - input_start)) * (input - input_start);
    if (ch == 0) {document.documentElement.style.setProperty('--beam-0', output + "%");}
    else if (ch == 1) {document.documentElement.style.setProperty('--beam-1', output + "%");}
    else if (ch == 2) {document.documentElement.style.setProperty('--beam-2', output + "%");}
    else if (ch == 3) {document.documentElement.style.setProperty('--beam-3', output + "%");}
    else if (ch == 4) {document.documentElement.style.setProperty('--beam-4', output + "%");}
    else if (ch == 5) {document.documentElement.style.setProperty('--beam-5', output + "%");}
    else if (ch == 6) {document.documentElement.style.setProperty('--beam-6', output + "%");}
    else if (ch == 7) {document.documentElement.style.setProperty('--beam-7', output + "%");}
    else if (ch == 8) {document.documentElement.style.setProperty('--beam-8', output + "%");}
    else if (ch == 9) {document.documentElement.style.setProperty('--beam-9', output + "%");}
    else if (ch == 10) {document.documentElement.style.setProperty('--beam-10', output + "%");}
    else if (ch == 11) {document.documentElement.style.setProperty('--beam-11', output + "%");}
    else if (ch == 12) {document.documentElement.style.setProperty('--beam-12', output + "%");}
    else if (ch == 13) {document.documentElement.style.setProperty('--beam-13', output + "%");}
    else if (ch == 14) {document.documentElement.style.setProperty('--beam-14', output + "%");}
    else if (ch == 15) {document.documentElement.style.setProperty('--beam-15', output + "%");}
}